"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var client_dynamodb_1 = require("@aws-sdk/client-dynamodb");
var luxon_1 = require("luxon");
/*
-- uncomment this block for development and debug
console.log(process.env.AWS_REGION)
console.log(process.env.DYNAMODB_CREDENTIAL_TABLE)
getCredential(process.env.AWS_REGION, process.env.DYNAMODB_CREDENTIAL_TABLE, 'xxxx-xxxx-xxxxx')
*/
function getCredential(_a) {
    var awsRegion = _a.awsRegion, dynamodbTable = _a.dynamodbTable, key = _a.key;
    return __awaiter(this, void 0, void 0, function () {
        var client, getItemCommandInput, response, credential, usageCounter, updateItemCommandInput, error_1, updateItemCommandInput, error_2;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    client = new client_dynamodb_1.DynamoDBClient({ region: awsRegion });
                    getItemCommandInput = {
                        TableName: dynamodbTable,
                        Key: {
                            key: { S: key }
                        },
                        AttributesToGet: ['enabled', 'credential', 'usageCounter']
                    };
                    return [4 /*yield*/, client.send(new client_dynamodb_1.GetItemCommand(getItemCommandInput))];
                case 1:
                    response = _b.sent();
                    if (!response.Item) return [3 /*break*/, 10];
                    if (!(response.Item.enabled && response.Item.enabled.BOOL)) return [3 /*break*/, 6];
                    credential = response.Item.credential.S;
                    usageCounter = +response.Item.usageCounter.N;
                    updateItemCommandInput = {
                        TableName: dynamodbTable,
                        Key: {
                            key: {
                                S: key
                            }
                        },
                        UpdateExpression: 'SET lastAccessedAt = :val1, lastUsedAt = :val1, usageCounter=:val2',
                        ExpressionAttributeValues: {
                            ':val1': { S: luxon_1.DateTime.now().toISO() },
                            ':val2': { N: "".concat(usageCounter + 1) }
                        }
                    };
                    _b.label = 2;
                case 2:
                    _b.trys.push([2, 4, , 5]);
                    return [4 /*yield*/, client.send(new client_dynamodb_1.UpdateItemCommand(updateItemCommandInput))
                        // Return the credential string
                    ];
                case 3:
                    _b.sent();
                    // Return the credential string
                    return [2 /*return*/, credential];
                case 4:
                    error_1 = _b.sent();
                    return [2 /*return*/, null];
                case 5: return [3 /*break*/, 10];
                case 6:
                    updateItemCommandInput = {
                        TableName: dynamodbTable,
                        Key: {
                            key: { S: key }
                        },
                        UpdateExpression: 'SET lastAccessedAt = :val1',
                        ExpressionAttributeValues: {
                            ':val1': { S: luxon_1.DateTime.now().toISO() }
                        }
                    };
                    _b.label = 7;
                case 7:
                    _b.trys.push([7, 9, , 10]);
                    return [4 /*yield*/, client.send(new client_dynamodb_1.UpdateItemCommand(updateItemCommandInput))
                        // Return the credential string
                    ];
                case 8:
                    _b.sent();
                    // Return the credential string
                    return [2 /*return*/, null];
                case 9:
                    error_2 = _b.sent();
                    return [2 /*return*/, null];
                case 10: return [2 /*return*/];
            }
        });
    });
}
exports.default = getCredential;
